=== debian/changelog ===
linux-entra-sso (1.2.0-1) unstable; urgency=medium

  * Initial release.

 -- Luca Boccassi <bluca@debian.org>  Tue, 26 Nov 2024 23:05:45 +0000
