=== debian/control ===
Source: linux-entra-sso
Section: contrib/web
Priority: optional
Maintainer: Luca Boccassi <bluca@debian.org>
Build-Depends: debhelper-compat (= 13), python3:native,
Homepage: https://github.com/siemens/linux-entra-sso
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/linux-entra-sso
Vcs-Git: https://salsa.debian.org/debian/linux-entra-sso.git

Package: linux-entra-sso
Architecture: all
Depends: ${misc:Depends}, python3, python3-gi, python3-pydbus,
Suggests: chromium | chromium-browser, firefox
Enhances: chromium, chromium-browser, firefox
Description: Entra ID SSO via Microsoft Identity Broker on Linux
 Local native host messaging connector for Firefox/Chromium/Chrome extension to
 implement Entra ID SSO Conditional Access, connecting to the Identity Broker
 via D-Bus.
