## linux-entra-sso 1.7.1

=== debian/changelog ===
linux-entra-sso (1.7.1-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.7.1'
  * Add alternate firefox-esr suggests/enhances
  * d/copyright: duplicate URLs from d/u/metadata

 -- Luca Boccassi <bluca@debian.org>  Thu, 25 Dec 2025 13:23:35 +0000

linux-entra-sso (1.5.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.0'

 -- Luca Boccassi <bluca@debian.org>  Thu, 21 Aug 2025 11:28:36 +0100

linux-entra-sso (1.4.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.4.0'
  * d/control: bump Standards-Version to 4.7.2, no changes

 -- Luca Boccassi <bluca@debian.org>  Wed, 04 Jun 2025 10:24:17 +0100

linux-entra-sso (1.3.1-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.3.1'

 -- Luca Boccassi <bluca@debian.org>  Wed, 15 Jan 2025 09:49:22 +0000

linux-entra-sso (1.3.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.3.0'

 -- Luca Boccassi <bluca@debian.org>  Mon, 13 Jan 2025 13:21:12 +0000
