## linux-entra-sso 1.7.2

=== Makefile ===
--- 
+++ 
@@ -39,7 +39,15 @@
 
 COMMON_INPUT_FILES= \
 	LICENSES/MPL-2.0.txt \
-	background.js \
+	src/account.js \
+	src/background.js \
+	src/broker.js \
+	src/device.js \
+	src/platform.js \
+	src/policy.js \
+	src/utils.js \
+	icons/profile-outline_48.png \
+	icons/profile-outline_48.png.license \
 	popup/menu.css \
 	popup/menu.js \
 	popup/menu.html
@@ -48,39 +56,60 @@
 	$(COMMON_INPUT_FILES) \
 	platform/chrome/manifest.json \
 	platform/chrome/manifest.json.license \
+	platform/chrome/js/platform-chrome.js \
+	platform/chrome/js/platform-factory.js \
+	platform/chrome/storage-schema.json \
+	platform/chrome/storage-schema.json.license \
+	icons/linux-entra-sso_48.png \
+	icons/linux-entra-sso_48.png.license \
+	icons/linux-entra-sso_128.png \
+	icons/linux-entra-sso_128.png.license
+
+FIREFOX_INPUT_FILES= \
+	$(COMMON_INPUT_FILES) \
+	platform/firefox/manifest.json \
+	platform/firefox/manifest.json.license \
+	platform/firefox/js/platform-firefox.js \
+	platform/firefox/js/platform-factory.js \
+	icons/linux-entra-sso.svg \
+	icons/profile-outline.svg
+
+THUNDERBIRD_INPUT_FILES= \
+	$(COMMON_INPUT_FILES) \
+	platform/thunderbird/manifest.json \
+	platform/thunderbird/manifest.json.license \
+	platform/thunderbird/js/platform-thunderbird.js \
+	platform/thunderbird/js/platform-factory.js \
+	icons/linux-entra-sso.svg \
+	icons/profile-outline.svg
+
+# common files for all platforms (relative to build directory)
+CHROME_PACKAGE_FILES= \
+	$(COMMON_INPUT_FILES) \
+	src/platform-chrome.js \
+	src/platform-factory.js \
+	manifest.json \
+	manifest.json.license \
+	storage-schema.json \
+	storage-schema.json.license \
 	icons/linux-entra-sso_48.png \
 	icons/linux-entra-sso_48.png.license \
 	icons/linux-entra-sso_128.png \
 	icons/linux-entra-sso_128.png.license \
-	icons/profile-outline_48.png \
-	icons/profile-outline_48.png.license
-
-FIREFOX_INPUT_FILES= \
-	$(COMMON_INPUT_FILES) \
-	platform/firefox/manifest.json \
-	platform/firefox/manifest.json.license \
-	icons/linux-entra-sso.svg \
-	icons/profile-outline.svg
-
-# common files for all platforms (relative to build directory)
-CHROME_PACKAGE_FILES= \
-	$(COMMON_INPUT_FILES) \
-	manifest.json \
-	manifest.json.license \
-	icons/linux-entra-sso_48.png \
-	icons/linux-entra-sso_48.png.license \
-	icons/linux-entra-sso_128.png \
-	icons/linux-entra-sso_128.png.license \
-	icons/profile-outline_48.png \
-	icons/profile-outline_48.png.license \
 	popup/profile-outline.svg
 
 FIREFOX_PACKAGE_FILES= \
 	$(COMMON_INPUT_FILES) \
+	src/platform-firefox.js \
+	src/platform-factory.js \
 	manifest.json \
 	manifest.json.license \
 	icons/linux-entra-sso.svg \
 	popup/profile-outline.svg
+
+THUNDERBIRD_PACKAGE_FILES= \
+	$(FIREFOX_PACKAGE_FILES) \
+	src/platform-thunderbird.js
 
 UPDATE_VERSION='s|"version":.*|"version": "$(VERSION)",|'
 UPDATE_VERSION_PY='s|0.0.0-dev|$(WEBEXT_VERSION)|g'
@@ -98,17 +127,24 @@
 DEBIAN_PKG_DIR = $(CURDIR)/pkgs
 DEBIAN_PKG_FILE = $(DEBIAN_PKG_DIR)/$(DEBIAN_PN)_$(DEBIAN_PV)_$(DEBIAN_ARCH).deb
 
-all package: clean $(CHROME_INPUT_FILES) $(FIREFOX_INPUT_FILES)
-	for P in firefox chrome; do \
+all package: clean $(CHROME_INPUT_FILES) $(FIREFOX_INPUT_FILES) $(THUNDERBIRD_INPUT_FILES)
+	for P in firefox thunderbird chrome; do \
 		mkdir -p build/$$P/icons build/$$P/popup; \
 		cp platform/$$P/manifest* build/$$P; \
-		cp -rf LICENSES background.js build/$$P/; \
+		cp -rf LICENSES src build/$$P/; \
+		cp platform/$$P/js/* build/$$P/src; \
 	done
-	cp icons/*.svg build/firefox/icons/
+	cp -r build/firefox/icons build/firefox/popup build/thunderbird/
+	cp platform/chrome/storage* build/chrome/
+	cp icons/*.svg icons/profile-outline_48.* build/firefox/icons/
 	cp icons/*.png* icons/profile-outline.svg build/chrome/icons/
 	cp popup/menu.* icons/linux-entra-sso.svg icons/profile-outline.svg build/firefox/popup/
 	cp popup/menu.* icons/linux-entra-sso.svg icons/profile-outline.svg build/chrome/popup/
+# thunderbird is almost identical to Firefox
+	cp -r build/firefox/icons build/firefox/popup build/thunderbird/
+	cp build/firefox/src/platform-firefox.js build/thunderbird/src/
 	cd build/firefox && zip -r ../$(ARCHIVE_NAME).firefox.xpi $(FIREFOX_PACKAGE_FILES) && cd ../../;
+	cd build/thunderbird && zip -r ../$(ARCHIVE_NAME).thunderbird.xpi $(THUNDERBIRD_PACKAGE_FILES) && cd ../../;
 	cd build/chrome && zip -r ../$(ARCHIVE_NAME).chrome.zip $(CHROME_PACKAGE_FILES) && cd ../../;
 
 deb:
@@ -146,7 +182,7 @@
 		exit 1;					\
 	fi
 	${Q}sed -i $(UPDATE_VERSION) platform/*/manifest.json
-	git commit -s platform/firefox/manifest.json platform/chrome/manifest.json -m "Bump version number"
+	git commit -s platform/firefox/manifest.json platform/thunderbird/manifest.json platform/chrome/manifest.json -m "Bump version number"
 	git tag -as v$(VERSION) -m "Release v$(VERSION)"
 
 local-install-firefox:
@@ -169,7 +205,26 @@
 	install -m 0755 linux-entra-sso.py ~/.config/google-chrome
 	${Q}sed -i $(UPDATE_VERSION_PY) ~/.config/google-chrome/linux-entra-sso.py
 
-local-install: local-install-firefox local-install-chrome
+local-install-brave:
+	install -d ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts
+	install -m 0644 platform/chrome/linux_entra_sso.json ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts
+	${Q}sed -i 's|/usr/local/lib/linux-entra-sso/|'$(HOME)'/.config/BraveSoftware/Brave-Browser/|' ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux_entra_sso.json
+	# compute extension id and and grant permission
+	${Q}sed -i 's|{extension_id}|$(CHROME_EXT_ID)|' ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux_entra_sso.json
+	install -m 0755 linux-entra-sso.py ~/.config/BraveSoftware/Brave-Browser
+	${Q}sed -i $(UPDATE_VERSION_PY) ~/.config/BraveSoftware/Brave-Browser/linux-entra-sso.py
+
+local-install: local-install-firefox local-install-chrome local-install-brave
+
+# For testing, we provide a mock implementation of the broker communication
+local-install-mock: local-install
+	install -m 0755 tests/linux_entra_sso_mock.py ~/.mozilla
+	${Q}sed -i 's|linux-entra-sso.py|linux_entra_sso_mock.py|' ~/.mozilla/native-messaging-hosts/linux_entra_sso.json
+	install -m 0755 tests/linux_entra_sso_mock.py ~/.config/google-chrome
+	${Q}sed -i 's|linux-entra-sso.py|linux_entra_sso_mock.py|' ~/.config/google-chrome/NativeMessagingHosts/linux_entra_sso.json
+	${Q}sed -i 's|linux-entra-sso.py|linux_entra_sso_mock.py|' ~/.config/chromium/NativeMessagingHosts/linux_entra_sso.json
+	install -m 0755 tests/linux_entra_sso_mock.py ~/.config/BraveSoftware/Brave-Browser
+	${Q}sed -i 's|linux-entra-sso.py|linux_entra_sso_mock.py|' ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux_entra_sso.json
 
 install:
 	${Q}[ -z "$(python3_bin)" ] && { echo "python3 not found. Please set 'python3_bin'."; exit 1; } || true
@@ -209,6 +264,7 @@
 	rm -f ~/.config/google-chrome/NativeMessagingHosts/linux_entra_sso.json ~/.config/google-chrome/linux-entra-sso.py
 	rm -f ~/.config/chromium/NativeMessagingHosts/linux_entra_sso.json
 
-local-uninstall: local-uninstall-firefox local-uninstall-chrome
-
-.PHONY: clean release local-install-firefox local-install-chrome local-install install local-uninstall-firefox local-uninstall-chrome local-uninstall uninstall deb deb_clean
+local-uninstall-brave:
+	rm -f ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux_entra_sso.json ~/.config/BraveSoftware/Brave-Browser/linux-entra-sso.py
+	rm -f ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux-entra-sso.py
+
