=== debian/changelog ===
linux-entra-sso (1.7.2-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.7.2'
  * Drop priority from d/control, now defaults to optional
  * Drop Rules-Requires-Root, now defaults to no
  * Bump Standards-version to 4.7.3
  * Update description to mention himmelblau

 -- Luca Boccassi <bluca@debian.org>  Fri, 30 Jan 2026 14:29:42 +0000
