=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

# Use debian/postinst to install the Chrome conffile
# and debian/postrm to remove it since dpkg's automatic
# conffile handling doesn't handle the special /etc/opt/ directory
# https://bugs.debian.org/888549
execute_after_dh_install:
	mkdir -p debian/linux-entra-sso/usr/share/linux-entra-sso
	mv debian/linux-entra-sso/etc/opt/chrome/native-messaging-hosts/linux_entra_sso.json \
		debian/linux-entra-sso/usr/share/linux-entra-sso/linux_entra_sso.json
	rm -rf debian/linux-entra-sso/etc/opt
