## linux-entra-sso 1.8.0

=== Makefile ===
--- 
+++ 
@@ -22,6 +22,12 @@
 chrome_nm_dir ?= /etc/opt/chrome/native-messaging-hosts
 chrome_ext_dir ?= /usr/share/google-chrome/extensions
 chromium_nm_dir ?= /etc/chromium/native-messaging-hosts
+# local install path
+brave_lconfig_dir ?= $(HOME)/.config/BraveSoftware/Brave-Browser
+firefox_lconfig_dir ?= $(HOME)/.mozilla
+chrome_lconfig_dir ?= $(HOME)/.config/google-chrome
+chromium_lconfig_dir ?= $(HOME)/.config/chromium
+vivaldi_lconfig_dir ?= $(HOME)/.config/vivaldi
 # python3 system interpreter for global installs
 python3_bin ?= $(shell which python3)
 
@@ -34,7 +40,7 @@
 PACKAGE_NAME=Linux-Entra-SSO
 
 RELEASE_TAG ?= $(shell git describe --match "v[0-9].[0-9]*" --dirty)
-WEBEXT_VERSION=$(shell echo $(RELEASE_TAG) | sed -e s:^v::)
+WEBEXT_VERSION=$(RELEASE_TAG:v%=%)
 ARCHIVE_NAME=$(PACKAGE_NAME)-$(RELEASE_TAG)
 
 COMMON_INPUT_FILES= \
@@ -119,7 +125,7 @@
 CHROME_EXT_ID_SIGNED=jlnfnnolkbjieggibinobhkjdfbpcohn
 
 # debian package related vars
-DEBIAN_PV = $(shell echo $(RELEASE_TAG) | sed -e s:^v::)
+DEBIAN_PV = $(RELEASE_TAG:v%=%)
 DEBIAN_PN = linux-entra-sso
 DEBIAN_DESCRIPTION = Entra ID SSO via Microsoft Identity Broker on Linux
 DEBIAN_DESTDIR := $(CURDIR)/debuild.d
@@ -143,14 +149,15 @@
 # thunderbird is almost identical to Firefox
 	cp -r build/firefox/icons build/firefox/popup build/thunderbird/
 	cp build/firefox/src/platform-firefox.js build/thunderbird/src/
-	cd build/firefox && zip -r ../$(ARCHIVE_NAME).firefox.xpi $(FIREFOX_PACKAGE_FILES) && cd ../../;
-	cd build/thunderbird && zip -r ../$(ARCHIVE_NAME).thunderbird.xpi $(THUNDERBIRD_PACKAGE_FILES) && cd ../../;
-	cd build/chrome && zip -r ../$(ARCHIVE_NAME).chrome.zip $(CHROME_PACKAGE_FILES) && cd ../../;
+	cd build/firefox && zip -r ../$(ARCHIVE_NAME).firefox.xpi $(FIREFOX_PACKAGE_FILES)
+	cd build/thunderbird && zip -r ../$(ARCHIVE_NAME).thunderbird.xpi $(THUNDERBIRD_PACKAGE_FILES)
+	cd build/chrome && zip -r ../$(ARCHIVE_NAME).chrome.zip $(CHROME_PACKAGE_FILES)
 
 deb:
+	install --mode 00755 --directory $(DEBIAN_DESTDIR)
 	$(MAKE) install DESTDIR=$(DEBIAN_DESTDIR) python3_bin=/usr/bin/python3 prefix=/usr
 	install --mode 644 -D --target-directory=$(DEBIAN_DESTDIR)/usr/share/doc/$(DEBIAN_PN) README.md CONTRIBUTING.md MAINTAINERS.md PRIVACY.md LICENSES/MPL-2.0.txt
-	install --mode 755 --directory $(DEBIAN_DESTDIR)/DEBIAN
+	install --mode 00755 --directory $(DEBIAN_DESTDIR)/DEBIAN
 	{ \
 		echo Package: $(DEBIAN_PN); \
 		echo Architecture: $(DEBIAN_ARCH); \
@@ -185,66 +192,73 @@
 	git commit -s platform/firefox/manifest.json platform/thunderbird/manifest.json platform/chrome/manifest.json -m "Bump version number"
 	git tag -as v$(VERSION) -m "Release v$(VERSION)"
 
+#######################
+# local install targets
+#######################
+
 local-install-firefox:
-	install -d ~/.mozilla/native-messaging-hosts
-	install -m 0644 platform/firefox/linux_entra_sso.json ~/.mozilla/native-messaging-hosts
-	${Q}sed -i 's|/usr/local/lib/linux-entra-sso/|'$(HOME)'/.mozilla/|' ~/.mozilla/native-messaging-hosts/linux_entra_sso.json
-	install -m 0755 linux-entra-sso.py ~/.mozilla
-	${Q}sed -i $(UPDATE_VERSION_PY) ~/.mozilla/linux-entra-sso.py
+	install -d $(firefox_lconfig_dir)/native-messaging-hosts
+	install -m 0644 platform/firefox/linux_entra_sso.json $(firefox_lconfig_dir)/native-messaging-hosts
+	${Q}sed -i 's|/usr/local/lib/linux-entra-sso/|'$(firefox_lconfig_dir)'/|' $(firefox_lconfig_dir)/native-messaging-hosts/linux_entra_sso.json
+	install -m 0755 linux-entra-sso.py $(firefox_lconfig_dir)
+	${Q}sed -i $(UPDATE_VERSION_PY) $(firefox_lconfig_dir)/linux-entra-sso.py
+
+# Helper target for installing Chromium-based browsers
+# Usage: make local-install-chromium-based BROWSER_CONFIG_PATH=~/.config/chromium
+local-install-chromium-based:
+	install -d $(BROWSER_CONFIG_PATH)/NativeMessagingHosts
+	install -m 0644 platform/chrome/linux_entra_sso.json $(BROWSER_CONFIG_PATH)/NativeMessagingHosts
+	${Q}sed -i 's|/usr/local/lib/linux-entra-sso/|'$(BROWSER_CONFIG_PATH)'/|' $(BROWSER_CONFIG_PATH)/NativeMessagingHosts/linux_entra_sso.json
+# compute extension id and and grant permission
+	${Q}sed -i 's|{extension_id}|$(CHROME_EXT_ID)|' $(BROWSER_CONFIG_PATH)/NativeMessagingHosts/linux_entra_sso.json
+	install -m 0755 linux-entra-sso.py $(BROWSER_CONFIG_PATH)
+	${Q}sed -i $(UPDATE_VERSION_PY) $(BROWSER_CONFIG_PATH)/linux-entra-sso.py
+
+local-install-brave:
+	$(MAKE) local-install-chromium-based BROWSER_CONFIG_PATH=$(brave_lconfig_dir)
 
 local-install-chrome:
-	install -d ~/.config/google-chrome/NativeMessagingHosts
-	install -d ~/.config/chromium/NativeMessagingHosts
-	install -m 0644 platform/chrome/linux_entra_sso.json ~/.config/google-chrome/NativeMessagingHosts
-	install -m 0644 platform/chrome/linux_entra_sso.json ~/.config/chromium/NativeMessagingHosts
-	${Q}sed -i 's|/usr/local/lib/linux-entra-sso/|'$(HOME)'/.config/google-chrome/|' ~/.config/google-chrome/NativeMessagingHosts/linux_entra_sso.json
-	${Q}sed -i 's|/usr/local/lib/linux-entra-sso/|'$(HOME)'/.config/google-chrome/|' ~/.config/chromium/NativeMessagingHosts/linux_entra_sso.json
-	# compute extension id and and grant permission
-	${Q}sed -i 's|{extension_id}|$(CHROME_EXT_ID)|' ~/.config/google-chrome/NativeMessagingHosts/linux_entra_sso.json
-	${Q}sed -i 's|{extension_id}|$(CHROME_EXT_ID)|' ~/.config/chromium/NativeMessagingHosts/linux_entra_sso.json
-	install -m 0755 linux-entra-sso.py ~/.config/google-chrome
-	${Q}sed -i $(UPDATE_VERSION_PY) ~/.config/google-chrome/linux-entra-sso.py
-
-local-install-brave:
-	install -d ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts
-	install -m 0644 platform/chrome/linux_entra_sso.json ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts
-	${Q}sed -i 's|/usr/local/lib/linux-entra-sso/|'$(HOME)'/.config/BraveSoftware/Brave-Browser/|' ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux_entra_sso.json
-	# compute extension id and and grant permission
-	${Q}sed -i 's|{extension_id}|$(CHROME_EXT_ID)|' ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux_entra_sso.json
-	install -m 0755 linux-entra-sso.py ~/.config/BraveSoftware/Brave-Browser
-	${Q}sed -i $(UPDATE_VERSION_PY) ~/.config/BraveSoftware/Brave-Browser/linux-entra-sso.py
-
-local-install: local-install-firefox local-install-chrome local-install-brave
+	$(MAKE) local-install-chromium-based BROWSER_CONFIG_PATH=$(chrome_lconfig_dir)
+
+local-install-chromium:
+	$(MAKE) local-install-chromium-based BROWSER_CONFIG_PATH=$(chromium_lconfig_dir)
+
+local-install-vivaldi:
+	$(MAKE) local-install-chromium-based BROWSER_CONFIG_PATH=$(vivaldi_lconfig_dir)
+
+local-install: local-install-brave local-install-chrome local-install-chromium local-install-firefox local-install-vivaldi
 
 # For testing, we provide a mock implementation of the broker communication
 local-install-mock: local-install
-	install -m 0755 tests/linux_entra_sso_mock.py ~/.mozilla
-	${Q}sed -i 's|linux-entra-sso.py|linux_entra_sso_mock.py|' ~/.mozilla/native-messaging-hosts/linux_entra_sso.json
-	install -m 0755 tests/linux_entra_sso_mock.py ~/.config/google-chrome
-	${Q}sed -i 's|linux-entra-sso.py|linux_entra_sso_mock.py|' ~/.config/google-chrome/NativeMessagingHosts/linux_entra_sso.json
-	${Q}sed -i 's|linux-entra-sso.py|linux_entra_sso_mock.py|' ~/.config/chromium/NativeMessagingHosts/linux_entra_sso.json
-	install -m 0755 tests/linux_entra_sso_mock.py ~/.config/BraveSoftware/Brave-Browser
-	${Q}sed -i 's|linux-entra-sso.py|linux_entra_sso_mock.py|' ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux_entra_sso.json
+	install -m 0755 tests/linux_entra_sso_mock.py $(brave_lconfig_dir)/linux_entra_sso.py
+	install -m 0755 tests/linux_entra_sso_mock.py $(chrome_lconfig_dir)/linux_entra_sso.py
+	install -m 0755 tests/linux_entra_sso_mock.py $(chromium_lconfig_dir)/linux_entra_sso.py
+	install -m 0755 tests/linux_entra_sso_mock.py $(firefox_lconfig_dir)/linux_entra_sso.py
+	install -m 0755 tests/linux_entra_sso_mock.py $(vivaldi_lconfig_dir)/linux_entra_sso.py
+
+####################################
+# system install / uninstall targets
+####################################
 
 install:
 	${Q}[ -z "$(python3_bin)" ] && { echo "python3 not found. Please set 'python3_bin'."; exit 1; } || true
-	# Host application
+# Host application
 	install -d $(DESTDIR)/$(libexecdir)/linux-entra-sso
 	install -m 0755 linux-entra-sso.py $(DESTDIR)/$(libexecdir)/linux-entra-sso
 	${Q}sed -i $(UPDATE_VERSION_PY) $(DESTDIR)/$(libexecdir)/linux-entra-sso/linux-entra-sso.py
 	${Q}sed -i $(UPDATE_PYTHON_INTERPRETER) $(DESTDIR)/$(libexecdir)/linux-entra-sso/linux-entra-sso.py
-	# Firefox
+# Firefox
 	install -d $(DESTDIR)/$(firefox_nm_dir)
 	install -m 0644 platform/firefox/linux_entra_sso.json $(DESTDIR)/$(firefox_nm_dir)
 	${Q}sed -i 's|/usr/local/lib/|'$(libexecdir)/'|' $(DESTDIR)/$(firefox_nm_dir)/linux_entra_sso.json
-	# Chrome
+# Chrome
 	install -d $(DESTDIR)/$(chrome_nm_dir)
 	install -m 0644 platform/chrome/linux_entra_sso.json $(DESTDIR)/$(chrome_nm_dir)
 	${Q}sed -i 's|/usr/local/lib/|'$(libexecdir)/'|' $(DESTDIR)/$(chrome_nm_dir)/linux_entra_sso.json
 	${Q}sed -i '/{extension_id}/d' $(DESTDIR)/$(chrome_nm_dir)/linux_entra_sso.json
 	install -d $(DESTDIR)/$(chrome_ext_dir)
 	install -m 0644 platform/chrome/extension.json $(DESTDIR)/$(chrome_ext_dir)/$(CHROME_EXT_ID_SIGNED).json
-	# Chromium
+# Chromium
 	install -d $(DESTDIR)/$(chromium_nm_dir)
 	install -m 0644 platform/chrome/linux_entra_sso.json $(DESTDIR)/$(chromium_nm_dir)
 	${Q}sed -i 's|/usr/local/lib/|'$(libexecdir)/'|' $(DESTDIR)/$(chromium_nm_dir)/linux_entra_sso.json
@@ -257,14 +271,27 @@
 	rm -f  $(DESTDIR)/$(chromium_nm_dir)/linux_entra_sso.json
 	rm -f  $(DESTDIR)/$(chrome_ext_dir)/$(CHROME_EXT_ID_SIGNED).json
 
+#########################
+# local uninstall targets
+#########################
+
+local-uninstall-brave:
+	rm -f $(brave_lconfig_dir)/NativeMessagingHosts/linux_entra_sso.json
+	rm -f $(brave_lconfig_dir)/linux-entra-sso.py
+
+local-uninstall-chrome:
+	rm -f $(chrome_lconfig_dir)/NativeMessagingHosts/linux_entra_sso.json
+	rm -f $(chrome_lconfig_dir)/linux-entra-sso.py
+
+local-uninstall-chromium:
+	rm -f $(chromium_lconfig_dir)/NativeMessagingHosts/linux_entra_sso.json
+	rm -f $(chromium_lconfig_dir)/linux-entra-sso.py
+
 local-uninstall-firefox:
-	rm -f ~/.mozilla/native-messaging-hosts/linux_entra_sso.json ~/.mozilla/linux-entra-sso.py
-
-local-uninstall-chrome:
-	rm -f ~/.config/google-chrome/NativeMessagingHosts/linux_entra_sso.json ~/.config/google-chrome/linux-entra-sso.py
-	rm -f ~/.config/chromium/NativeMessagingHosts/linux_entra_sso.json
-
-local-uninstall-brave:
-	rm -f ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux_entra_sso.json ~/.config/BraveSoftware/Brave-Browser/linux-entra-sso.py
-	rm -f ~/.config/BraveSoftware/Brave-Browser/NativeMessagingHosts/linux-entra-sso.py
-
+	rm -f $(firefox_lconfig_dir)/native-messaging-hosts/linux_entra_sso.json
+	rm -f $(firefox_lconfig_dir)/linux-entra-sso.py
+
+local-uninstall-vivaldi:
+	rm -f $(vivaldi_lconfig_dir)/NativeMessagingHosts/linux_entra_sso.json
+	rm -f $(vivaldi_lconfig_dir)/linux-entra-sso.py
+
