=== debian/changelog ===
linux-entra-sso (1.8.0-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Luca Boccassi <bluca@debian.org>  Tue, 24 Feb 2026 10:49:06 +0000

linux-entra-sso (1.8.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.8.0'

 -- Luca Boccassi <bluca@debian.org>  Tue, 17 Feb 2026 09:52:47 +0000

linux-entra-sso (1.7.2-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Luca Boccassi <bluca@debian.org>  Thu, 05 Feb 2026 15:34:02 +0000
