=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/linux-entra-sso-?(\d\S+)\.tar\.gz/linux-entra-sso_$1\.orig\.tar\.gz/ \
  https://github.com/siemens/linux-entra-sso/tags .*/v?(\d\S+)\.tar\.gz
